package com.hungraim.ism.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ism.dao.DisableApplyMapper;
import com.hungraim.ism.dao.DistrictMapper;
import com.hungraim.ism.dao.FndOrganMapper;
import com.hungraim.ism.pojo.vo.disable.DisableExamineInfoVO;
import com.hungraim.ism.pojo.vo.disable.DisableVO;
import com.hungraim.ism.pojo.vo.disable.ExamineRecord;
import com.hungraim.ism.service.DisableService;
import com.hungraim.ltc.pojo.entity.disable.ChDisableApply;
import com.hungraim.ltc.pojo.entity.disable.ChFndDistrict;
import com.hungraim.ltc.pojo.entity.disable.ChFndOrgan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DisableServiceImpl implements DisableService {

    @Autowired
    private DisableApplyMapper disableApplyMapper;
    @Autowired
    private DistrictMapper districtMapper;
    @Autowired
    private FndOrganMapper fndOrganMapper;

    @Override
    public Page<DisableVO> disableList(String organId, String districtProvincial, String districtCity,
                                       String districtArea, String realName, String certiCode, String dataFrom,
                                       String srvOrganId, int page, int pageSize) {
        return disableApplyMapper.disableList(new Page<>(page, pageSize), organId, districtProvincial,
                districtCity, districtArea, realName, certiCode, dataFrom, srvOrganId);
    }

    @Override
    public DisableExamineInfoVO disableExamineInfo(String applyId) {
        DisableExamineInfoVO disableExamineInfoVO = disableApplyMapper.selectDisableExamineInfoByApplyId(applyId);
        List<ExamineRecord> examineRecords = disableApplyMapper.listExamineRecordByApplyId(applyId);
        disableExamineInfoVO.setExamineRecords(examineRecords);
        return disableExamineInfoVO;
    }

    @Override
    public void addDisable(ChDisableApply chDisableApply) {
        disableApplyMapper.insert(chDisableApply);
    }

    @Override
    public void disableExamine(String applyId, String checkName, Short applyStatus, String checkRemark) {
        ChDisableApply chDisableApply = disableApplyMapper.selectById(applyId);
        chDisableApply.setCheckName(checkName);
        chDisableApply.setApplyStatus(applyStatus);
        chDisableApply.setCheckRemark(checkRemark);
    }

    @Override
    public List<ChFndDistrict> district(String districtLevel, String districtCode) {
        QueryWrapper<ChFndDistrict> queryWrapper = new QueryWrapper<ChFndDistrict>();
        queryWrapper.eq("DISTRICT_LEVEL", districtLevel);
        if (!"1".equals(districtLevel)) {
            queryWrapper.eq("PARENT_DISTIRCT_CODE", districtCode);
        }
        return districtMapper.selectList(queryWrapper);
    }

    @Override
    public List<ChFndOrgan> fndOrganRoot() {
        QueryWrapper<ChFndOrgan> queryWrapper = new QueryWrapper<ChFndOrgan>();
        queryWrapper.eq("IS_LEAF", "1");
        return fndOrganMapper.selectList(queryWrapper);
    }

}